# Walker mechanism
print('ウォーカー・メカニズム')
print()

import numpy as np

# プレーヤーの数： 
N = 3

# 公共財からの便益： 
# v = G-0.5*a[i]*G**2
# 便益関数のパラメータ：
a = [1,1,1]

# 公共財生産の限界費用：
Q = 1

# 費用負担割合
q = [0]*N
for i in range(N):
    q[i]=Q/N
    print('プレーヤー',i+1,'の費用負担割合 = ',q[i]) 
print()

# 連立1次方程式AX=Bを解く

# 左辺の係数行列の値を設定
A = np.matrix([
    [1,0,2],
    [2,1,0],
    [0,2,1]
])

# 右辺の定数ベクトルの値を設定
B = np.matrix([
    [1.0-q[0]],
    [1.0-q[1]],
    [1.0-q[2]]
])

# 連立1次方程式の解を求める
s = np.linalg.solve(A,B)

# ナッシュ均衡における各プレーヤーの表明する公共財追加需要
x=[0]*N
for i in range(N):
    x[i]=s[i,0] 
    print('プレーヤー',i+1,'の表明する公共財追加需要 = ',x[i]) 
print()

# 公共財供給水準の決定
G = sum(x) 
print('公共財供給水準 = ',G)
print()

# 追加費用負担割合の計算
t = [0]*N
for i in range(N):
    left=(i+1)%N
    right=(i-1)%N
    t[i]=x[right]-x[left] 
    print('プレーヤー',i+1,'の追加費用負担割合 = ',t[i]) 

# 各プレーヤーの利得
payoff = [0]*N
for i in range(N):
    payoff[i] = G-0.5*a[i]*G**2-(q[i]+t[i])*G
    print('プレーヤー',i+1,'の利得 = ',payoff[i]) 
